#ifndef BRVIEW_H
#define BRVIEW_H

// Including gtk/gtk.h would require having `pkg-config --cflags gtk+-3.0`
// in all Makefiles that use this library. To avoid that, we don't use
// any gtk types in this header file.

typedef struct {
	void *window;	// really GtkWidget *window
	void *fixed;	// really GtkWidget *fixed
} brview_t;

typedef struct {
	unsigned char *data;	// the image data
	int x;					// the x coordinate relative to its container
	int y;					// the y coordinate relative to its container
	int width;				// width in pixels
	int height;				// height in pixels
	int stride;				// number of actual bytes per row
	// the remaining members area for internal use only
    void *surface;			// really cairo_surface_t *surface;
    void *drawing_area;		// really GtkWidget *drawing_area;
} brview_image_t;

brview_t *brview_setup(int argc, char **argv);
int brview_image_get_stride(int width);
brview_image_t *brview_image_create(brview_t *bv, unsigned char *data, int x, int y, int width, int height, int stride);
int brview_image_update(brview_image_t *img);

#endif
